
<?php


/******
 * 色の設定
 */
define("MISS_ANS_BACKGROUND", "salmon"); //間違った解答の背景色を設定する
define("MISS_ANS_MISSTITLE", "darkred"); //間違った解答の、間違いのタイトル背景色を設定する
define("MISS_ANS_MISSTABLE1", "pink"); //間違った解答の、間違いの位置と訂正例の背景色を設定する
define("MISS_ANS_MISSTABLE2", "white"); //間違った解答の、間違いの種類の背景色を設定する
define("CORRECT_ANS_BACKGROUND", "skyblue"); //正解の背景色を設定する

/******
 * 添削済み解答結果を５件ごとに表示するボタンを作成する
 */
function make_buttons_to_view_five_answers($anslog_list) {
	$size_of_anslog_list = count($anslog_list);
	echo "<form action='' method='POST'>";
	$i = 0;
	while ($i < $size_of_anslog_list) {
		$start_point = $i +1;
		echo "<input type='submit'  name='start_point' value='".$start_point."～". ($start_point +4)."'>";
		$i = $i +5;
	}
	echo " </form> ";
}

/******
 * 全解答結果リストから、
 * 与えられた解答番号範囲の解答を表示する
 */
function print_anslog_list_by_answer_number($anslog_list, $start_point, $length) {
	$start_point = $start_point -1;
	$anslog_list_to_print = array_slice($anslog_list, $start_point, $length);
	print_anslog_list($anslog_list_to_print);
}

/******
 * 添削結果一覧を表示する
 */
function print_anslog_list($anslog_list) {
	//--注釈--
	//phpではグローバル変数は関数内で宣言しなければならないため、ここでも宣言
	//http://php.s3.to/man/language.variables.scope.html
	foreach ($anslog_list as $key => $value) {
		if (answer_is_corrected($value) == true) {
			$anslog_table_bgcolor = select_table_background($value);
			echo "<table width='75%' border=1 bgcolor='$anslog_table_bgcolor'><tr><td>問題：";
			echo "$value->problem";
			echo "</td></tr>\n";
			echo "<tr><td>あなたの解答：";
			echo "$value->answer";
			echo "<tr><td>\n";
			if (answer_is_correct($value) == false) {
				foreach ($value->mistakes as $misskey => $miss) {
					echo "<table width='100%'><tr><td bgcolor='darkred' colspan=3><font color='white'>あなたの解答：";
					echo make_markedproblem_from_problem_and_number_list($value->answer, $miss->location);
					echo "</font></tr></td>\n";

					echo "<tr><td bgcolor='pink'>";
					echo "$miss->location";
					echo "</td>\n";

					echo "<td bgcolor='white'>";
					echo "$miss->type";
					echo "：$miss->correction<br>";
					echo "</td>\n";

					echo "<td bgcolor='pink'>";
					echo "$miss->answer_comment";
					echo "</td></tr></table>\n";
					echo "<br>\n";
				}
			} else {
				echo "正解です<br>\n";
			}

			echo "<tr><td>この問題の正解例：";
			echo "$value->correctans";
			echo "<tr><td>\n";

			echo "<tr><td>解答時間：";
			echo "$value->anstime";
			echo "<tr><td>\n";

			echo "</table>";
			echo "<br>\n";
		} else {
			echo "<table width='75%' border=1 bgcolor='#999999'><tr><td>問題：";
			echo "$value->problem";
			echo "</td></tr>\n";
			echo "<tr><td>あなたの解答：";
			echo "$value->answer";
			echo "<tr><td>\n";
			echo "<tr><td>解答時間：";
			echo "$value->anstime";
			echo "<tr><td>\n";

			echo "</table>";
			echo "<br>\n";
		}
	}
}

/******
 * 解答に間違いがあるかどうかによってテーブルの背景色を変更する
 */
function select_table_background($anslog) {
	global $anslog_table_bgcolor;

	//間違いがあるかどうか調べて
	if (answer_is_correct($anslog) == false) { //間違いがあれば背景色を「間違い色」にする
		$anslog_table_bgcolor = MISS_ANS_BACKGROUND;
	} else {
		$anslog_table_bgcolor = CORRECT_ANS_BACKGROUND; //間違いがなければ背景色を「正解色」にする
	}
	return $anslog_table_bgcolor;
}

/******
 * 表示する
 */

//make_anslog_list();
//make_buttons_to_view_five_answers($anslog_list);
//print_anslog_list($anslog_list);
//echo"<hr>";
//print_anslog_list_by_answer_number($anslog_list,0,3);

/******
 *　カンマ区切りの数字（3,4,5）をばらばら(3)(4)(5)にする
 */
function explode_comma($comma_text) {
	$numbers = explode(",", $comma_text);
	return $numbers;
}

/******
 * マークされた文字の位置の配列(3)(4)(5)と
 * 文字列（えおあいう。）から、マークされた文字が赤太字になっている文字列を作成する
 */
function make_markedproblem_from_problem_and_numbers($problem, $numbers) {
	$size_of_problem = mb_strlen($problem); //問題文の文字数
	$marked_problem = "";
	$letter_pointer = 0;
	while ($letter_pointer < $size_of_problem) {
		if (letter_ismarked($letter_pointer, $numbers) == false) {
			//マークされていない文字は、そのまま返す文字列に格納する
			$letter = mb_substr($problem, $letter_pointer, 1);
			$marked_problem = $marked_problem.$letter;
		} else {
			//マークされている文字は、赤太字にして返す文字列に格納する
			$letter = mb_substr($problem, $letter_pointer, 1);
			$letter = set_letter_to_bold_letter($letter);
			$marked_problem = $marked_problem.$letter;
		}
		$letter_pointer ++;
	}
	return $marked_problem;
}

/******
 * マークされた文字のリスト（3,4,5）と問題文から
 * マークされた文字が赤太字になってい問題文を作成する
 */
function make_markedproblem_from_problem_and_number_list($problem, $number_list) {
	if ($number_list == "NOT_SET") {
		$markedproblem = "間違いの位置は登録されていません";
	} else {
		$numbers = explode_comma($number_list);
		$markedproblem = make_markedproblem_from_problem_and_numbers($problem, $numbers);
	}
	return $markedproblem;
}

/******
 * 与えられた文字を赤太字にして返す
 */
function set_letter_to_bold_letter($letter) {
	$letter = "<B><font color='red'>".$letter."</font></b>";
	return $letter;
}

/******
 * マルチバイト対応文字列位置指定置換関数
 * （substr_replaceのマルチバイト版）
 * PHP Manualより引用
 * http://jp2.php.net/manual/ja/function.substr-replace.php
 */
//Check to see if it exists in case PHP has this function later
if (!function_exists("mb_substr_replace")) {
	//Same parameters as substr_replace with the extra encoding parameter.
	function mb_substr_replace($string, $replacement, $start, $length = null, $encoding = null) {
		if ($encoding == null) {
			if ($length == null) {
				return mb_substr($string, 0, $start).$replacement;
			} else {
				return mb_substr($string, 0, $start).$replacement.mb_substr($string, $start + $length);
			}
		} else {
			if ($length == null) {
				return mb_substr($string, 0, $start, $encoding).$replacement;
			} else {
				return mb_substr($string, 0, $start, $encoding).$replacement.mb_substr($string, $start + $length, mb_strlen($string, $encoding), $encoding);
			}
		}
	}
}

/******
 * 解答が正解かどうか調べる
 */
function answer_is_correct($answer) {
	$first_correction = $answer->mistakes[0];
	if (isset($first_correction->location)) {
		return false;
	} else {
		return true;
	}
}

/******
 * 解答が添削済みかどうか調べる
 */
function answer_is_corrected($answer) {
	if (isset($answer->correctans)) {
		return true;
	} else {
		return false;
	}
}

/******
 * 問題文の◎番目の文字がマークされているかどうか調べる
 */
function letter_ismarked($letter_pointer, $marked_numbers) {
	$ismarked = false;
	foreach ($marked_numbers as $marked_number) {
		if ($marked_number == $letter_pointer) {
			$ismarked = true;
		}
	}
	return $ismarked;
}
?>


