<?php


/**
 * AnswerData.php
 * 学生の回答データを扱う機能
 * author 川口
 */

require_once ('DBAccessor.php');

/*****************
 * public methods*
 *****************/
/**
 * 学生が回答した問題の履歴と回答の履歴を取得する
 * @$login : ログイン名
 */
function getAnswerHistory($login) {
	$query = "SELECT
						answer.answer_id, answer, answer_time, is_corrected,
						question, correct_example
					FROM
						answer, question
					WHERE answer.question_id = question.question_id
					AND answer.student_login_name = '$login'";

	// 学生が回答した問題の履歴と回答の履歴を取得する
	connect();
	$result = mysql_query($query);
	close();

	$i = 0;
	$answer = null;
	while ($row = mysql_fetch_object($result)) {
		if ($row->is_corrected == 1) {
			// 添削済みだった場合
			$answer[$i]->answer_id = $row->answer_id; //解答ID
			$answer[$i]->answer = $row->answer; //学生の解答
			$answer[$i]->anstime = $row->answer_time; //学生の解答時間
			$answer[$i]->problem = $row->question; //問題文
			$answer[$i]->correctans = $row->correct_example; //正解例
			$mistake = getCorrection($row->answer_id);
			$answer[$i]->mistakes = $mistake;
		} else {
			$answer[$i]->answer_id = $row->answer_id; //解答ID
			$answer[$i]->answer = $row->answer; //学生の解答
			$answer[$i]->anstime = $row->answer_time; //学生の解答時間
			$answer[$i]->problem = $row->question; //問題文
		}

		$i ++;
	}
	return $answer;

}

/**
 * 次に添削される回答を取得する
 */
function getNextToBeCorrected() {
	$query = "SELECT answer FROM answer
							WHERE answer.is_corrected = FALSE LIMIT 1;";

	// 次に添削される解答を取得する
	connect();
	$result = mysql_query($query);
	close();

	if (mysql_num_rows($result) == 1) {
		$row = mysql_fetch_object($result);
		$nextAnswer = $row->answer;
	} else
		$nextAnswer = null;

	return $nextAnswer;
}

/**
 * 添削済みの回答のみ取得する
 */
function getCorrectedAnswer($question_id) {
	$query = "SELECT answer FROM answer
					WHERE answer.question_id = $question_id
					AND answer.is_corrected = TRUE;";

	connect();
	$result = mysql_query($query);
	close();

	$i = 0;
	$correctedAnswer[] = null;
	while ($row = mysql_fetch_object($result)) {
		$correctedAnswer[$i] = $row->answer;

		$i ++;
	}

	return $correctedAnswer;
}

/**
 * 回答を追加する
 * @$answer : 回答文
 * @$question_id : 問題ID
 * @$login : ログイン名
 */
function addAnswer($answer, $question_id, $login) {
	global $time;

	$query = "INSERT INTO answer(question_id, student_login_name, answer, answer_time, is_corrected)
				VALUES($question_id, '$login', '$answer', '$time', FALSE);";

	// 回答を追加する
	connect();
	$result = mysql_query($query);

	// 追加した回答のIDを取得する
	global $db;
	$answer_id = mysql_insert_id($db);

	// 重複している回答を自動添削する
	require_once ('CorrectionData.php');
	if (($existingAnswer_id = isInCorrected($answer_id, $answer, $question_id)) != null) {
		// 添削済みの回答郡の中に、全く同じ回答が存在した場合
		// 存在した回答の添削を取得する
		$existingCorrectionIDs = getCorrectionConnectless($existingAnswer_id);

		if ($existingCorrectionIDs != null) {
			// 同じ内容の回答に添削がついていた場合
			// 追加された回答へ同じ添削をつける
			foreach ($existingCorrectionIDs as $value) {
				foreach ($value as $walue) {
					addCorrectionToMirror($walue, $answer_id);
				}
			}
		}
	}
	close();

	return $result;
}

/**
 * 添削済みな回答の中に、同じ回答がないか調べる
 */
function isInCorrected($answer_id, $answer, $question_id) {
	$query = "SELECT answer_id FROM answer
				WHERE answer.question_id = $question_id
				AND answer.answer = '$answer'
				AND answer.is_corrected = TRUE 
				AND answer.answer_id != $answer_id LIMIT 1;";

	$result = mysql_query($query);

	// 問題に対する初の回答であった場合
	if (!$result || mysql_num_rows($result) <= 0) {
		return null;
	}

	$row = mysql_fetch_object($result);

	return $row->answer_id;
}

/**
 * 添削済みな回答の中に、同じ回答がないか調べて、
 * 同じ解答の解答IDをすべて返す
 */
function isInCorrected_getAnswerIds($answer, $question_id) {
	$query = "SELECT answer_id FROM answer
				WHERE answer.question_id = $question_id
				AND answer.answer = '$answer'
				AND answer.is_corrected = TRUE;";

	connect();
	$result = mysql_query($query);
	close();
	$i = 0;
	$answer_ids[] = null;
	while ($row = mysql_fetch_object($result)) {
		$answer_ids[$i] = $row->answer_id;
		$i++;
    }
	return $answer_ids;
}

/******************
 * private methods*
 ******************/
/**
 * 学生の回答に対する添削を取得する
 * @$answer_id : 回答ID
 */
function getCorrection($answer_id) {
	$query = "SELECT
						answer_comment, correction_spot,
						correction_kind, correction_kind_comment,correction_kind.correction_kind_id
					FROM
						correction, correction_kind, correction_object
					WHERE correction.correction_kind_id = correction_kind.correction_kind_id
					AND correction_object.answer_id = '$answer_id'
					AND correction_object.correction_id = correction.correction_id;";

	// 学生の回答に対する添削を取得する
	connect();
	$result = mysql_query($query);
	close();
	if (!$result) {
		return;
	}

	$i = 0;
	$correction = null;
	while ($row = mysql_fetch_object($result)) {
		$correction[$i]->answer_comment = $row->answer_comment;
		$correction[$i]->type = $row->correction_kind;
		if ($row->correction_kind_id != 1) {
			// 回答が正解ではなかった場合
			$correction[$i]->location = $row->correction_spot;
			$correction[$i]->correction = $row->correction_kind_comment;
		}

		$i ++;
	}

	return $correction;
}

function getCorrectionConnectless($answer_id) {
	$query = "SELECT
						correction_id
					FROM
						correction_object
					WHERE correction_object.answer_id = '$answer_id';";

	// 学生の回答に対する添削を取得する
	$result = mysql_query($query);

	if (!$result) {
		return;
	}

	$correction = null;
	$i = 0;
	while ($row = mysql_fetch_object($result)) {
		$correction[$i]->correction_id = $row->correction_id;

		$i ++;
	}

	return $correction;
}
?>



