<?php

/**
 * 学生の回答データを扱う機能郡
 */

require_once ('DBAccessor.php');

/**
 * 回答の情報を取得するときのフォーマット
 */
class Answer {
	var $answer_id;
	var $answer;
	var $anstime;
	var $problem;
	var $correctans;
	var $mistakes;
}

/**
 * 添削の情報を取得するときのフォーマット
 */
class Correction {
	var $right_answer;
	var $answer_comment;
	var $correction_range;
	var $location;
	var $type;
	var $correction;
}

/**
 * 学生が回答した問題の履歴と回答の履歴を取得する
 * @$login : ログイン名
 */
/*
$getAHTest = getAnswerHistory('s00000aa');
foreach($getAHTest as $key => $value) {
	//echo($value->correction->answer_comment."<br>");
	
	foreach($value as $walue) {
		echo($walue."<br>");
	}
	
	echo("<br>");
}
*/
function getAnswerHistory($login) {
	$query = "SELECT
				answer_id, answer, answer_time, is_corrected,
				question, correct_example
			FROM
				answer, question
			WHERE answer.question_id = question.question_id
			AND answer.student_login_name = '".$login."';";

	// 学生が回答した問題の履歴と回答の履歴を取得する
	connect();
	$result = mysql_query($query);
	close();

	$i = 0;
	$answer[] = new Answer();
	while ($row = mysql_fetch_object($result)) {
		if ($row->is_corrected == 1) {
			// 添削済みだった場合
			$answer[$i]->answer_id = $row->answer_id; //解答ID
			$answer[$i]->answer = $row->answer; //学生の解答
			$answer[$i]->anstime = $row->answer_time; //学生の解答時間
			$answer[$i]->problem = $row->question; //問題文
			$answer[$i]->correctans = $row->correct_example; //正解例
			$mistake = getCorrection($row->answer_id);
			$answer[$i]->mistakes = $mistake;
		}

		$i ++;
	}

	return $answer;
}

/**
 * 添削を取得する
 * @$answer_id : 回答ID
 */
/*
$getCorTest = getCorrection(3);
foreach($getCorTest as $key => $value) {
	foreach($value as $walue) {
		echo($walue."<br>");
	}
	
	echo("<br>");
}
*/
function getCorrection($answer_id) {
	$query = "SELECT
				answer_comment, correction_spot,
				correction_kind, correction_kind_comment
			FROM
				correction, correction_kind
			WHERE correction.correction_kind_id = correction_kind.correction_kind_id
			AND correction.answer_id = '".$answer_id."';";

	// 学生の回答に対する添削を取得する
	connect();
	$result = mysql_query($query);
	close();

	$i = 0;
	$correction[] = new Correction();
	while ($row = mysql_fetch_object($result)) {
		$correction[$i]->answer_comment = $row->answer_comment;
		$correction[$i]->type = $row->correction_kind;
		if ($row->correction_kind != 1) {
			// 回答が正解ではなかった場合
			$correction[$i]->location = $row->correction_spot;
			$correction[$i]->correction = $row->correction_kind_comment;
		}

		$i ++;
	}

	return $correction;
}

/**
 * getCorrectionのconnect/close無し版
 */
function getCorrectionAccessless($answer_id) {
	$query = "SELECT
				answer_comment, correction_spot, correction_kind.correction_kind_id,
				correction_kind, correction_kind_comment
			FROM
				correction, correction_kind
			WHERE correction.correction_kind_id = correction_kind.correction_kind_id
			AND correction.answer_id = '".$answer_id."';";
	// 学生の回答に対する添削を取得する
	connect();
	$result = mysql_query($query);

	$i = 0;
	$correction[] = new Correction();
	while ($row = mysql_fetch_object($result)) {
		$correction[$i]->answer_comment = $row->answer_comment;
		$correction[$i]->correction_kind_id = $row->correction_kind_id;
		$correction[$i]->type = $row->correction_kind;
		if ($row->correction_kind != 1) {
			// 回答が正解ではなかった場合
			$correction[$i]->location = $row->correction_spot;
			$correction[$i]->correction = $row->correction_kind_comment;
		}

		$i ++;
	}

	return $correction;
}

/**
 * 次に添削される回答を取得する
 */
/*
//echo(getNextToBeCorrected());
function getNextToBeCorrected() {
	$query = "SELECT answer, question_id FROM answer
			WHERE answer.is_corrected = FALSE LIMIT 1;";
	
	// 次に添削される解答を取得する
	connect();
	while(true) {
		$result = mysql_query($query);
		
		if(mysql_num_rows($result) == 1) {
			$row = mysql_fetch_object($result);
			$nextAnswer = $row->answer;
			$question_id = $row->question_id;
		} else {
			close();
			$nextAnswer = null;
		}
		echo("#################");
		// 拾ってきた回答が既に添削されている回答と同じ場合
		if(($existingCorrection_id = isInCorrected($nextAnswer, $question_id)) != null) {
			echo("hogehoge");
			// 同じ回答の添削を拾ってきて、自動的に添削する
			$existingCorrections = getCorrectionAccessless($existingCorrection_id);
			if(existingCorrections != null) {
				foreach($existingCorrections as $value) {
					addCorrectionAccessless($question_id, $value->correction_kind_id, $value->location, $value->answer_comment);
				}
			}
			
			continue;
		}
		
		break;
	}
	
	close();
	
	return $nextAnswer;
}
*/

/**
 * 添削済みの回答のみ取得する
 */
/*
$getCrAns = getCorrectedAnswer(1);
foreach($getCrAns as $value) {
	echo($value."<br>");
}
*/
function getCorrectedAnswer($question_id) {
	$query = "SELECT answer FROM answer
			WHERE answer.question_id = $question_id
			AND answer.is_corrected = TRUE;";

	connect();
	$result = mysql_query($query);
	close();

	$i = 0;
	$correctedAnswer[] = null;
	while ($row = mysql_fetch_object($result)) {
		$correctedAnswer[$i] = $row->answer;

		$i ++;
	}

	return $correctedAnswer;
}

/**
 * 回答を追加する
 * @$answer : 回答文
 * @$question_id : 問題ID
 * @$login : ログイン名
 */
//$addAnswerTest = addAnswer('よくわからんです(^ω^)', '3', 's22222cc');
//if($addAnswerTest) echo("回答が追加されたよ");

//	if(addAnswer('ぷぎゃーなんじゃね？', 3, 's00000aa')) echo("回答が追加されました");

function addAnswer($answer, $question_id, $login) {
	global $time;

	$query = "INSERT INTO
					answer(question_id, student_login_name, answer, answer_time, is_corrected)
					VALUES($question_id, '$login', '$answer', '$time', FALSE);";

	connect();
	// 回答を追加する
	$result = mysql_query($query);

	// 重複している回答を自動添削する
	require_once ('CorrectionData.php');
	if (($existingAnswer_id = isInCorrected($answer, $question_id)) != null) {
		// 添削済みの回答郡の中に、全く同じ回答が存在した場合
		// 存在した回答の添削を取得する
		$existingCorrections = getCorrectionAccessless($existingAnswer_id);

		if ($existingCorrections != null) {
			// 被っている回答の数を調べる
			$getExistingNum = "SELECT answer_id FROM answer
							WHERE answer.answer = '$answer' AND answer.student_login_name = '$login'";
			$getExistingNumResult = mysql_query($getExistingNum);
			$existingNum = mysql_num_rows($getExistingNumResult);
			$existingNumPre = $existingNum -1;

			// たった今追加された回答のIDを取得（たった今追加された回答は、回答が一致しログイン名も一致する回答の中の最後尾のものとして処理している・・・可能性はごく極めて低いとはいえ、バグは起こりうる）
			$getThisId = "SELECT answer_id FROM answer
							WHERE answer.answer = '$answer' AND answer.student_login_name = '$login' LIMIT $existingNumPre, $existingNum;";
			$getThisIdResult = mysql_query($getThisId);
			if ($getThisIdResult) {
				$row = mysql_fetch_object($getThisIdResult);
			}

			// たった今追加された回答へ、存在した回答に対する添削と同様の添削を埋め込む
			foreach ($existingCorrections as $value) {
				addCorrectionAccessless($row->answer_id, $value->correction_kind_id, $value->location, $value->answer_comment);
			}
		}
	}
	close();

	return $result;
}

/**
 * 今までの回答の中に同じ回答が含まれていないか調べる
 */
/*
if(($hoge = isInCorrected('あいうえおあ', 2)) != null) {
	echo("既に添削済みな回答郡に存在している回答だよ！");
	echo($hoge);
} else {
	echo("添削済みの回答郡の中では初めての回答だったよ");
}
*/
function isInCorrected($answer, $question_id) {
	$query = "SELECT answer_id FROM answer WHERE
					answer.question_id = $question_id AND answer.answer = '$answer' AND answer.is_corrected = TRUE LIMIT 1;";

	connect();
	$result = mysql_query($query);

	// 問題に対する初の回答であった場合
	if (!$result || mysql_num_rows($result) <= 0) {
		return null;
	}

	$row = mysql_fetch_object($result);

	return $row->answer_id;
}
?>

