<?php

/**
 * 添削に必要なデータを扱う機能部
 * MegumiAraki 2006/12/20
 */

require_once ('DBAccessor.php');


/*****************
 * public methods*
 *****************/
/**
 * 未添削の中で一番最初の回答を取得する
 */
function getUnCorrectedAnswerSet() {
	$query = "select * from question,answer where answer.is_corrected=FALSE and answer.question_id=question.question_id ORDER BY answer.answer LIMIT 1;";

	// 未添削の解答、解答ID,問題、問題IDを取得する
	connect();

	while (true) {
		$result = mysql_query($query);

		if (!$result || mysql_num_rows($result) <= 0) {
			close();
			return null;
		}
		
		$answer_set = null;
		while ($row = mysql_fetch_object($result)) {
			$answer_set->answer_id = $row->answer_id;
			$answer_set->answer = $row->answer;
			$answer_set->question_id = $row->question_id;
			$answer_set->question = $row->question;
		}

		// 重複した回答を自動添削する
		require_once ('AnswerData.php');
		require_once ('CorrectionData.php');
		if (($correctedAnswerID = isInCorrected($answer_set->answer_id, $answer_set->answer, $answer_set->question_id)) != null) {
		// 添削済みの中に同じ回答が存在した場合
			// 同じ回答の添削を拾ってきて、自動的に添削する
			$existingCorrections = getCorrectionConnectless($correctedAnswerID);
			foreach ($existingCorrections as $value) {
				foreach($value as $walue) {
					addCorrectionToMirror($walue, $answer_set->answer_id);
				}
			}

			continue;
		}

		break;
	}
	
	close();

	return $answer_set;
}

function deleteCorrectionLink($correction_id) {
	$deleteLink =
	"DELETE FROM correction_object
		WHERE correction_object.correction_id = $correction_id;";
		
	connect();
	$deleteLinkResult = mysql_query($deleteLink);
	close();
	if(!$deleteLinkResult) {
		echo("添削のリンク削除に失敗しました");
		return;
	}
}

/**
 * 問題IDから解答をすべて取得する（問題ID)
 */
function getAllAnswersfromQuestionID($question_id) {
	$query = "SELECT answer,answer_id FROM answer WHERE answer.question_id = $question_id and answer.is_corrected=1";
	connect();
	$result = mysql_query($query);
	close();
	$i = 0;
	$answers = null;
	while ($row = mysql_fetch_object($result)) {
		$answers[$i]->answer = $row->answer;
		$answers[$i]->answer_id = $row->answer_id;
		$i ++;
	}

	return $answers;
}

/**
 * 解答IDから添削をすべて取得する（解答ID)
 */
function getAllCorrectionfromAnswerID($answer_id) {
	$query =
	"SELECT * FROM answer, question, correction, correction_object, correction_kind
	WHERE answer.answer_id = $answer_id
	AND answer.question_id = question.question_id
	AND correction_object.answer_id = $answer_id
	AND correction_object.correction_id = correction.correction_id
	AND correction.correction_kind_id = correction_kind.correction_kind_id;";
	
	connect();
	$result = mysql_query($query);
	close();
	if(!$result) {
		echo("この回答は未添削です");
		return null;
	}

	// 取得したデータを切り分けて扱える様にする
	$i = 0;
	$correction_set = null;
	while ($row = mysql_fetch_object($result)) {
		$correction_set[$i]->answer = $row->answer;
		$correction_set[$i]->answer_id = $row->answer_id;
		$correction_set[$i]->correction_id = $row->correction_id;
		$correction_set[$i]->correction_kind = $row->correction_kind;
		$correction_set[$i]->correction_kind_id = $row->correction_kind_id;
		$correction_set[$i]->answer_comment = $row->answer_comment;
		$correction_set[$i]->correction_spot = $row->correction_spot;
		$correction_set[$i]->question = $row->question;
		$correction_set[$i]->question_id = $row->question_id;

		$i ++;
	}

	return $correction_set;
}

/**
 * 全ての添削の種類を取得する
 */
function getCorrectionKinds() {
	$query = "SELECT *
			FROM correction_kind
			WHERE correction_kind.correction_kind_id > 1
			ORDER BY correction_kind;";

	connect();
	$result = mysql_query($query);
	close();

	$i = 0;
	$correction_kinds = null;
	while ($row = mysql_fetch_object($result)) {
		$correction_kinds[$i]->correction_kind_id = $row->correction_kind_id;
		$correction_kinds[$i]->correction_kind = $row->correction_kind;
		$correction_kinds[$i]->correction_kind_comment = $row->correction_kind_comment;
		$i ++;
	}

	return $correction_kinds;
}
?>

