<?php


/**
 * 添削内容を扱う機能郡
 */
require_once ('TestTools.php');
require_once ('../DBAccessor.php');
require_once ('../CorrectionData.php');

//doAllTests();
doTest("addCorrectionTest");

/**
 * すべてのテストを実行する
 */
function doAllTests() {
	doTest("getAnswerfromQuestionIDandAnswerTest");
	doTest("addCorrectionTest");
	doTest("correctDuplicationsTest");
	doTest("addCorrectionAccesslessTest");
	doTest("isInUncorrectedTest");
}

/**
 * 問題IDと回答文から解答IDのリストを取得する
 */
function getAnswerfromQuestionIDandAnswerTest() {
	$sameAnswerIDs = getAnswerfromQuestionIDandAnswer('ほげほげですよ', 1);
	foreach ($sameAnswerIDs as $value) {
		echo ($value);
	}

	return true;
}

/**
 * 添削を追加する
 * ※添削の種類が正解だった場合、添削の対象範囲にnullを入れる作業を
 * 画面側にやって貰うことになるかも
 * @$answer_id : 添削対象の回答ID
 * @$correction_kind_id : 添削の種類ID
 * @$correction_spot : 添削の対象範囲
 * @$answer_comment : 回答に対するコメント
 */
function addCorrectionTest() {
	if (addCorrection(5, 2, '1,3,5', 'ほげほげな回答ですね')) {
		echo ("添削が追加されたよ");
		return true;
	} else {
		return false;
	}
}

/**
 * 重複している回答を添削する
 */
function correctDuplicationsTest() {
	correctDuplications(1);

	return true;
}

/**
 * addCorrectionのclose()無し版
 */
function addCorrectionAccesslessTest($answer_id, $correction_kind_id, $correction_spot, $answer_comment) {
	addCorrectionAccessless(1, 3, '1,2,3', '何かがおかしいです');

	return true;
}

/**
 * 未添削な回答郡にある全く同じ回答のIDを取得する
 */
function isInUncorrectedTest() {
	if (($foo = isInUncorrected('ほげほげですよ', 2)) != null) {
		echo ("未添削な回答郡に全く同じ回答があったよ");
		echo ($foo);

		return true;
	} else {
		echo ("未添削な回答郡には同じ回答はなかったよ");

		return false;
	}
}
?>