<?php


/**
 * QuestionDataTest.php
 * 問題周りのデータを扱う機能郡
 */
require_once ('TestTools.php');
require_once ('../DBAccessor.php');
require_once ('../QuestionData.php');

doAllTests();

/**
 * すべてのテストを実行する
 */
function doAllTests() {
	doTest("getCandidateQuestionShowTest");
	doTest("getSelectedQuestionTest");
	doTest("addQuestionTest");
	doTest("adminInvisibleTest");
	doTest("studentVisibleTest");
	doTest("studentInvisibleTest");
	doTest("swapOrderTest");
	doTest("getExcelSourcesTest");
	doTest("getExcelSourceTest");
}

/**
 * 出題出来る問題を取得する
 */
function getCandidateQuestionShowTest() {
	$getCandiTest = getCandidateQuestion();
	foreach ($getCandiTest as $value) {
		echo ($value->question_id.":".$value->question."<br>");
	}
	
	return true;
}

/**
 * 出題されている問題を取得する
 */
function getSelectedQuestionTest() {
	$getSelectedTest = getSelectedQuestion();
	//echo(count($getSelectedTest));
	if ($getSelectedTest != null) {
		foreach ($getSelectedTest as $value) {
			foreach ($value as $walue) {
				echo ($walue."<br>");
			}
		}
	}
	
	return true;
}

/**
 * 問題を追加する
 * デフォルトでadminからは可視、学生からは不可視となる
 * @$question : 問題文
 * @$correct_example : 解答例
 */
function addQuestionTest() {
	if (addQuestion('テストだよほげ', 'How much roughly?')) {
		echo("追加成功");
		return true;
	} else {
		echo("追加失敗");
		return false;
	}
}

/**
 * adminから不可視にする
 * @$question_id : 問題ID
 */
function adminInvisibleTest() {
	if (adminInvisible(1)) {
		echo ("先生からも学生からも見えなくなったよ");
		return true;
	}
}

/**
 * 学生が問題を解ける様にする（回答画面から見える様にする）
 * ※adminから不可視で学生から可視にも出来るが、画面仕様上それは出来ない、かも
 */
function studentVisibleTest() {
	if (studentVisible(1)) {
		echo ("学生から見える様になったよ");
		return true;
	}
}

/**
 * 学生が問題を解けない様にする（回答画面から見えない様にする）
 * @$question : 問題ID
 */
function studentInvisibleTest() {
	if (studentInvisible(1)) {
		echo ("学生から見えなくなったよ");
		return true;
	}
}

/**
 * 問題の順番を入れ替える
 * @$question_id1 : 並べ替えたい問題その１
 * @$question_id2 : 並べ替えたい問題その２
 */
function swapOrderTest() {
	if (swapOrder(4, 5)) {
		echo ("入れ替わったよ");
		return true;
	} else {
		echo ("入れ替えられなかったよ");
		return false;
	}
}

/**
 * エクセル出力用のデータを取得する
 */
function getExcelSourcesTest() {
	$getExcelsTest = getExcelSources();
	foreach ($getExcelsTest as $value) {
		foreach ($value as $walue) {
			echo ($walue."<br>");
		}

		echo ("<br>");
	}
	
	return true;
}

/**
 * エクセル出力用のデータを問題指定で取得する
 * @$question_id : 問題ID
 */
function getExcelSourceTest() {
	$getExcelTest = getExcelSource(2);
	foreach ($getExcelTest as $value) {
		foreach ($value as $walue) {
			echo ($walue."<br>");
		}
	}
	
	return true;
}
?>




