<?php

/**
 * InitializeDatabase.php
 * データベースを初期化する
 * Author 荒木
 * 修正1回目 川口
 * Created on 2007/01/10
 * Updated on 2007/01/12
 *
 *！！注意！これを実行するとデータベースを初期化します。
 */

require_once ('../DBAccessors/DBAccessor.php');

echo "データベースを初期化します。（すでに入っているデータはすべて削除します）<BR>";
initializeDatabase();
echo "データベースを初期化しました。";


/**
 * データベースを初期化する
 */
function initializeDatabase() {
	executeQuery("DROP TABLE answer, correction, correction_kind, correction_object, question, student");

	executeQuery("CREATE TABLE answer (
  answer_id INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  question_id INTEGER UNSIGNED NOT NULL,
  student_login_name VARCHAR(20) NOT NULL,
  answer TEXT NOT NULL,
  answer_time DATETIME NOT NULL,
  is_corrected BOOL NOT NULL,
  PRIMARY KEY(answer_id),
  INDEX answer_FKIndex1(student_login_name),
  INDEX answer_FKIndex2(question_id)
)");
	
	executeQuery("CREATE TABLE correction (
  correction_id INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  correction_kind_id INTEGER UNSIGNED NOT NULL,
  answer_comment TEXT NULL,
  correction_spot TEXT NULL,
  PRIMARY KEY(correction_id),
  INDEX correction_FKIndex2(correction_kind_id)
)");

	executeQuery("CREATE TABLE correction_kind (
	  correction_kind_id INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
	  correction_kind TEXT NOT NULL,
	  correction_kind_comment TEXT NULL,
	  PRIMARY KEY(correction_kind_id)
	)");
	
	executeQuery("CREATE TABLE correction_object (
  correction_object_id INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  correction_id INTEGER UNSIGNED NOT NULL,
  answer_id INTEGER UNSIGNED NOT NULL,
  PRIMARY KEY(correction_object_id, correction_id, answer_id),
  INDEX correction_object_FKIndex1(correction_id),
  INDEX correction_object_FKIndex2(answer_id)
)");

	executeQuery("CREATE TABLE question (
  question_id INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  question TEXT NOT NULL,
  correct_example TEXT NULL,
  admin_visible BOOL NOT NULL,
  student_visible BOOL NOT NULL,
  question_order INTEGER UNSIGNED NULL,
  PRIMARY KEY(question_id)
)");

	executeQuery("CREATE TABLE student (
	  login_name VARCHAR(20),
	  passwd VARCHAR(20) NOT NULL,
	  name VARCHAR(45) NOT NULL,
	  clazz VARCHAR(45) NOT NULL,
	  register_time DATETIME NOT NULL,
	  PRIMARY KEY(login_name)
	)");

	executeQuery("INSERT INTO correction_kind(correction_kind, correction_kind_comment)
		VALUES('.正解です', '正解です')");

	executeQuery("INSERT INTO question(question, correct_example, admin_visible, student_visible)
		VALUES('この問題は番兵です。（シリアルナンバー問題の対応）', 'この問題は番兵です。', 0, 0)");
}

function executeQuery($query) {
	connect();
	$result = mysql_query($query);
	close();
	echo $result;
	echo "<BR>";
}


?>

