﻿CREATE TABLE student(
login_name VARCHAR(20) primary key NOT NULL,
password VARCHAR(20) NOT NULL,
name VARCHAR(45) NOT NULL,
class VARCHAR(45) NOT NULL,
register_time DATETIME NOT NULL
) default character set utf8;

CREATE TABLE answer(
answer_id INT auto_increment primary key NOT NULL,
answer TEXT NOT NULL,
question_id INT NOT NULL,
login_name VARCHAR(20) NOT NULL,
answer_time DATETIME NOT NULL
) default character set utf8;

CREATE TABLE question(
question_id INT auto_increment primary key NOT NULL,
question TEXT NOT NULL,
right_example TEXT NOT NULL,
teacher_visible BOOLEAN NOT NULL,
student_visible BOOLEAN NOT NULL
) default character set utf8;

CREATE TABLE correction(
correction_id INT auto_increment primary key NOT NULL,
right_answer BOOLEAN NOT NULL,
answer_comment TEXT,
range_start INT,
range_end INT,
answer_id INT NOT NULL,
kind_id INT
) default character set utf8;

CREATE TABLE correction_kind(
kind_id INT auto_increment primary key NOT NULL,
correction_kind TEXT NOT NULL,
kind_comment TEXT NOT NULL
) default character set utf8;



INSERT INTO student(login_name, password, name, class, register_time) VALUES('t04263mk', 'hogehoge', '川口 将司', 'ベーシックA', '2006-11-26 12:34:56');
INSERT INTO answer(answer_time, answer, login_name, question_id) VALUES('2006-11-26 23:45:12', 'Im walking in the park.', 't04263mk', 1);
INSERT INTO question(question, right_example, student_visible, teacher_visible) VALUES('わたしは街を歩いています。', 'Im walking in the town.', FALSE, TRUE);
INSERT INTO correction(right_answer, answer_comment, range_start, range_end, answer_id, kind_id) VALUES(0, '何を言っているんだチミは', 2, 4, 1, 1);
INSERT INTO correction_kind(correction_kind, kind_comment) VALUES('前置詞の位置が違います', '死ねばいいのに');

INSERT INTO student(login_name, password, name, class, register_time) VALUES('t04000yk', 'yuuuuuta', '黒木 雄太', 'ベーシックB', '2006-11-26 15:36:50');
INSERT INTO answer(answer_time, answer, login_name, question_id) VALUES('2006-11-26 23:45:12', 'Hes walking in the park.', 't04000yk', 2);
INSERT INTO question(question, right_example, student_visible, teacher_visible) VALUES('私は中国人です。', 'Im Chinese.', TRUE, TRUE);
INSERT INTO correction(right_answer, answer_comment, range_start, range_end, answer_id, kind_id) VALUES(0, 'おまえはアホか', 1, 5, 2, 2);
INSERT INTO correction_kind(correction_kind, kind_comment) VALUES('漢字が日本語です', '氏ね');

INSERT INTO answer(answer_time, answer, login_name, question_id) VALUES('2006-12-24 23:59:59', 'How are you?', 't04263mk', 3);
INSERT INTO answer(answer_time, answer, login_name, question_id) VALUES('2007-01-31 23:55:12', 'Go home.', 't04263mk', 6);
INSERT INTO answer(answer_time, answer, login_name, question_id) VALUES('2009-01-31 20:55:12', 'This is a hogehoge sentence.', 't04263mk', 2);
INSERT INTO answer(answer_time, answer, login_name, question_id) VALUES('2007-01-31 23:55:12', 'Yeah!', 't04263mk', 2);

INSERT INTO correction(right_answer, answer_comment, range_start, range_end, answer_id, kind_id)
VALUES(1, '正解だ！', null, null, 6, null);

SELECT * FROM answer, question, correction, correction_kind
					WHERE answer.question_id = question.question_id
					AND answer.answer_id = correction.answer_id
					AND correction.kind_id = correction_kind.kind_id
					AND answer.login_name = 't04263mk';