CREATE TABLE answer (
  answer_id INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  question_id INTEGER UNSIGNED NOT NULL,
  student_login_name VARCHAR(20) NOT NULL,
  answer TEXT NOT NULL,
  answer_time DATETIME NOT NULL,
  is_corrected BOOL NOT NULL,
  PRIMARY KEY(answer_id),
  INDEX answer_FKIndex1(student_login_name),
  INDEX answer_FKIndex2(question_id)
);

CREATE TABLE correction (
  correction_id INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  correction_kind_id INTEGER UNSIGNED NOT NULL,
  answer_comment TEXT NULL,
  correction_spot TEXT NULL,
  PRIMARY KEY(correction_id),
  INDEX correction_FKIndex2(correction_kind_id)
);

CREATE TABLE correction_kind (
  correction_kind_id INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  correction_kind TEXT NOT NULL,
  correction_kind_comment TEXT NULL,
  PRIMARY KEY(correction_kind_id)
);

CREATE TABLE correction_object (
  correction_object_id INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  correction_id INTEGER UNSIGNED NOT NULL,
  answer_id INTEGER UNSIGNED NOT NULL,
  PRIMARY KEY(correction_object_id, correction_id, answer_id),
  INDEX correction_object_FKIndex1(correction_id),
  INDEX correction_object_FKIndex2(answer_id)
);

CREATE TABLE question (
  question_id INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  question TEXT NOT NULL,
  correct_example TEXT NULL,
  admin_visible BOOL NOT NULL,
  student_visible BOOL NOT NULL,
  question_order INTEGER UNSIGNED NULL,
  PRIMARY KEY(question_id)
);

CREATE TABLE student (
  login_name VARCHAR(20) NOT NULL AUTO_INCREMENT,
  passwd VARCHAR(20) NOT NULL,
  name VARCHAR(45) NOT NULL,
  clazz VARCHAR(45) NOT NULL,
  register_time DATETIME NOT NULL,
  PRIMARY KEY(login_name)
);

INSERT INTO correction_kind(correction_kind, correction_kind_comment)
<<<<<<< junjun_DB3.sql
    VALUES('.正解です', '正解です');
INSERT INTO question(question, correct_example, admin_visible, student_visible)
    VALUES('!!この問題は削除して下さい', '!!この問題は削除して下さい', 1, 0);
=======
    VALUES('.正解です', '正解です');
>>>>>>> 1.3
