<?

// セッションを開始。
session_start();
// セッションに変数を登録
$_SESSION['PROBLEM'];
$_SESSION['PROBLEM_ID'];
$_SESSION['ANSWER'];
$_SESSION['ANSWER_ID'];
$_SESSION['CORRECTION_STATE'];
$_SESSION['VIEW_STATE'];
?>

<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>中国語研究室 SystemJUN ver.Shige</title>
</head>
<body>

<?php

require_once ("../DBAccessors/MarkingData.php");
require_once ("../Common/HTMLNormalizer.php");
require_once ("../DBAccessors/CorrectionKindData.php");
require_once ("../DBAccessors/CorrectionData.php");

$correction_state = 0; //添削の状態
define("NEW_CORRECTION", "1");
define("ADD_CORRECTION", "2");
define("OVERWRITE_CORRECTION", "3");

$view_state = 0; //画面の状態
define("FROM_MENU_VIEW", "1");
define("FROM_DONE_VIEW", "2");
define("FROM_EDIT_VIEW", "3");
define("FROM_THIS_VIEW", "4");

/**
 * 添削の状態を取得する
 */
function getCorrectionAndViewState() {
	//CORRECTION_STATE の判定
	//状態セッションが空だったら、デフォルトの状態を入れる。
	if ($_SESSION['CORRECTION_STATE'] == null) {
		$_SESSION['CORRECTION_STATE'] = NEW_CORRECTION;
	}
	
	//状態遷移hiddenフラグが立っていたら、状態を遷移させる。
	if (isset ($_POST['same_answer'])) { //添削を追加する場合（添削完了画面より）
		$_SESSION['CORRECTION_STATE'] = ADD_CORRECTION;
	}
	elseif (isset ($_POST['answer_from_edit_marking'])) {
		if (isset ($_POST['redo'])) { //添削をやりなおす場合（添削編集画面より）

			$_SESSION['CORRECTION_STATE'] = OVERWRITE_CORRECTION;
		} else { //添削を追加する場合（添削編集画面より）
			$_SESSION['CORRECTION_STATE'] = ADD_CORRECTION;
		}
	}
	
	//状態セッションから現在の状態を取得する。
	$correction_state = $_SESSION['CORRECTION_STATE'];
	
	//VIEW_STATE の判定(前バージョンとの整合性を保つために必要)
	//状態セッションが空だったら、デフォルトの状態を入れる。
	if ($_SESSION['VIEW_STATE'] == null) {
		$_SESSION['VIEW_STATE'] = FROM_MENU_VIEW;
	}
	
	//状態遷移hiddenフラグが立っていたら、状態を遷移させる。
	if (isset ($_POST['same_answer'])) { //添削完了画面でフラグを渡された場合
		$_SESSION['VIEW_STATE'] = FROM_DONE_VIEW;
	}
	elseif (isset ($_POST['answer_from_edit_marking'])) { //添削編集画面でフラグを渡された場合
		if (isset ($_POST['redo'])) { //上書きの場合
			$_SESSION['VIEW_STATE'] = FROM_EDIT_VIEW;
		} else { //追加の場合
			$_SESSION['VIEW_STATE'] = FROM_EDIT_VIEW;
		}
	}
	elseif (isset ($_POST['add_category'])) {
		$_SESSION['VIEW_STATE'] = FROM_THIS_VIEW;
	}

	//状態セッションから現在の状態を取得する。
	$view_state = $_SESSION['VIEW_STATE'];

	$correction_view_state->correction_state = $correction_state;
	$correction_view_state->view_state = $view_state;

	return $correction_view_state;
}


$correction_view_state = getCorrectionAndViewState();
$view_state = $correction_view_state->view_state;
$correction_state = $correction_view_state->correction_state;

/**
 * 添削に必要な情報を取得する
 */
function getDataForCorrection($correction_state, $view_state) {
	$answer_set=$_SESSION['ANSWER_SET'];
	return $answer_set;
}

/**
 * 添削用データをDBから取得する
 */
function getAnswerSetFromDB() {
	$answer_set = getUnCorrectedAnswerSet();
	return $answer_set;
}

/**
 * 添削用データを画面から取得する
 */
function getAnswerSetFromView($view_state) {
	if ($view_state == FROM_EDIT_VIEW) { //編集画面から遷移した場合
		$answer_from_edit_marking = $_POST['answer_from_edit_marking'];
		$answer_id_from_edit_marking = $_POST['answer_id_from_edit_marking'];
		$question_from_edit_marking = $_POST['question_from_edit_marking'];
		$question_id_from_edit_marking = $_POST['question_id_from_edit_marking'];
		$correction_id_from_edit_marking = $_POST['correction_id_from_edit_marking'];

		$answer_set->question = $question_from_edit_marking;
		$answer_set->question_id = $question_id_from_edit_marking;
		$answer_set->answer = $answer_from_edit_marking;
		$answer_set->answer_id = $answer_id_from_edit_marking;
		$answer_set->correction_id = $correction_id_from_edit_marking;

	} else
		if ($view_state == FROM_DONE_VIEW) { //完了画面から遷移した場合
			$answer_set->answer = $_SESSION['ANSWER'];
			$answer_set->answer_id = $_SESSION['ANSWER_ID'];
			$answer_set->question = $_SESSION['PROBLEM'];
			$answer_set->question_id = $_SESSION['PROBLEM_ID'];
		}
	return $answer_set;
}

/******
 * 不正解の位置を入力するチェックボックスを表示する
 */
function make_checkboxed_answer($answer) {
	$size_of_answer = mb_strlen($answer); //問題文の文字数
	$checkbox_added_answer = "";
	$letter_pointer = 0;
	while ($letter_pointer < $size_of_answer) {
		$letter = mb_substr($answer, $letter_pointer, 1);
		$letter = $letter."<input type=\"checkbox\" name=\"letters[]\" value=\"$letter_pointer\">\n";
		$checkbox_added_answer = $checkbox_added_answer.$letter;
		$letter_pointer ++;
	}
	print $checkbox_added_answer;
}

/*******************
*画面遷移後の処理***
********************/

//日付を取得する
$today = date('Y年m月d日');
//添削と画面の状態を取得する
$correction_view_state = getCorrectionAndViewState();
//添削に必要な情報を取得する
$correction_state = $correction_view_state->correction_state;
$view_state = $correction_view_state->view_state;
$answer_set = getDataForCorrection($correction_state, $view_state);

$uneditedanswer = $answer_set->answer;
$uneditedanswerquestion = $answer_set->question;
$uneditedanswerquestionid = $answer_set->question_id;
?>

<h1 align="center">不正解の種類追加画面</h1><br><br>
<table align="center">


<form method='POST' action="Correction_Review.php">
<h4>不正解の種類を追加する</h4>
不正解の種類の名称を決めてください
<br>
例）単語、文型、簡体字<br>
種類名：<input type="text" name ="correction_kind" size="10">
<br><br>
その不正解をしたときに表示するコメントを決めてください
<br>
例）単語の間違いです。
<br>
コメント：<input type="text" name ="correction_kind_comment" size="30">
<br><br>
<input type="submit" name ="add_category" value="追加する">
</form>
<br>
<?php

//添削する問題と回答を保存する
$_SESSION['PROBLEM'] = $answer_set->question;
$_SESSION['PROBLEM_ID'] = $answer_set->question_id;
$_SESSION['ANSWER'] = $answer_set->answer;
$_SESSION['ANSWER_ID'] = $answer_set->answer_id;
if ($uneditedanswer) {
	print "
		<hr>
		<h2>今添削している問題</h2>
		<h3>問題：$uneditedanswerquestion</h3>
		<h3>回答：$uneditedanswer</h3>
		<br>
		";
} else {
	print "<h3>未処理の回答はありません</h3>
		<form>
		<input type=\"button\" onClick=\"location.href='TeacherTop.php'\" value=\"TOPページに戻る\">
		</form>
		";
}
?><br><br>
<form>
<input type="button" onClick="location.href='TeacherTop.php'" value="TOPページに戻る">
</form>

</body>
</html>