<?


// セッションを開始。
session_start();
//// セッションに変数を登録
//$_SESSION['PROBLEM'];
//$_SESSION['PROBLEM_ID'];
//$_SESSION['ANSWER'];
//$_SESSION['ANSWER_ID'];
//$_SESSION['CORRECTION_ID'];
//$_SESSION['CORRECTION_STATE'];
//$_SESSION['VIEW_STATE'];
?>

<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>中国語研究室 SystemJUN ver.Shige</title>
</head>
<body>

<?php


require_once ("../DBAccessors/MarkingData.php");
require_once ("../Common/HTMLNormalizer.php");
require_once ("../DBAccessors/CorrectionKindData.php");
require_once ("../DBAccessors/CorrectionData.php");

$correction_state = 0; //添削の状態
define("NEW_CORRECTION", "1");
define("ADD_CORRECTION", "2");
define("OVERWRITE_CORRECTION", "3");

$view_state = 0; //画面の状態
define("FROM_MENU_VIEW", "1");
define("FROM_DONE_VIEW", "2");
define("FROM_EDIT_VIEW", "3");
define("FROM_THIS_VIEW", "4");

/**
 * 添削の状態を取得する
 */
function getCorrectionAndViewState() {
	//CORRECTION_STATE の判定
	//状態セッションが空だったら、デフォルトの状態を入れる。
	if (isset($_SESSION['CORRECTION_STATE']) == false) {
		$_SESSION['CORRECTION_STATE'] = NEW_CORRECTION;
	}
	
	//状態遷移hiddenフラグが立っていたら、状態を遷移させる。
	if (isset ($_POST['same_answer'])) { //添削を追加する場合（添削完了画面より）
		$_SESSION['CORRECTION_STATE'] = ADD_CORRECTION;
	}
	elseif (isset ($_POST['answer_from_edit_marking'])) {
		if (isset ($_POST['redo'])) { //添削をやりなおす場合（添削編集画面より）

			$_SESSION['CORRECTION_STATE'] = OVERWRITE_CORRECTION;
		} else { //添削を追加する場合（添削編集画面より）
			$_SESSION['CORRECTION_STATE'] = ADD_CORRECTION;
		}
	}elseif (isset($_POST['new_correction'])){
		$_SESSION['CORRECTION_STATE'] = NEW_CORRECTION;
	}
	
	//状態セッションから現在の状態を取得する。
	$correction_state = $_SESSION['CORRECTION_STATE'];
	
	//VIEW_STATE の判定(前バージョンとの整合性を保つために必要)
	//状態セッションが空だったら、デフォルトの状態を入れる。
	if (isset($_SESSION['VIEW_STATE']) == false) {
		$_SESSION['VIEW_STATE'] = FROM_MENU_VIEW;
	}
	
	//状態遷移hiddenフラグが立っていたら、状態を遷移させる。
	if (isset ($_POST['same_answer'])) { //添削完了画面でフラグを渡された場合
		$_SESSION['VIEW_STATE'] = FROM_DONE_VIEW;
	}
	elseif (isset ($_POST['answer_from_edit_marking'])) { //添削編集画面でフラグを渡された場合
		if (isset ($_POST['redo'])) { //上書きの場合
			$_SESSION['VIEW_STATE'] = FROM_EDIT_VIEW;
		} else { //追加の場合
			$_SESSION['VIEW_STATE'] = FROM_EDIT_VIEW;
		}
	}
	elseif (isset ($_POST['add_category'])) {
		$_SESSION['VIEW_STATE'] = FROM_THIS_VIEW;
	}elseif (isset($_POST['new_correction'])){
		$_SESSION['VIEW_STATE'] = FROM_MENU_VIEW;
	}

	//状態セッションから現在の状態を取得する。
	$view_state = $_SESSION['VIEW_STATE'];

	$correction_view_state->correction_state = $correction_state;
	$correction_view_state->view_state = $view_state;

	return $correction_view_state;
}

$correction_view_state = getCorrectionAndViewState();
$view_state = $correction_view_state->view_state;
$correction_state = $correction_view_state->correction_state;

////画面と添削の状態をデバッグ用に表示する。
//echo $view_state;
//echo $correction_state;

/**
 * 添削に必要な情報を取得する
 */
function getDataForCorrection($correction_state, $view_state) {
	//添削の状態を調べて
	if ($correction_state == NEW_CORRECTION) { //添削がされていない場合は
		//DBからデータを読み込む
		$answer_set = getAnswerSetFromDB();
	} else
		if ($correction_state == OVERWRITE_CORRECTION) { //添削をやり直す場合は
			//画面からデータを読み込む
			$answer_set = getAnswerSetFromView($view_state);
			$answer_id = $answer_set->answer_id;
			$correction_id = $answer_set->correction_id;
//			//DBから添削データを消去する
//			deleteCorrection($correction_id, $answer_id);
		} else
			if ($correction_state == ADD_CORRECTION) { //添削を追加する場合は
				//画面からデータを読み込む
				$answer_set = getAnswerSetFromView($view_state);
			}
	return $answer_set;
}

/**
 * 添削用データをDBから取得する
 */
function getAnswerSetFromDB() {
	$answer_set = getUnCorrectedAnswerSet();
	return $answer_set;
}

/**
 * 添削用データを画面から取得する
 */
function getAnswerSetFromView($view_state) {
	$answer_set=null;
	if ($view_state == FROM_EDIT_VIEW) { //編集画面から遷移した場合
		$answer_from_edit_marking = $_POST['answer_from_edit_marking'];
		$answer_id_from_edit_marking = $_POST['answer_id_from_edit_marking'];
		$question_from_edit_marking = $_POST['question_from_edit_marking'];
		$question_id_from_edit_marking = $_POST['question_id_from_edit_marking'];
		$correction_id_from_edit_marking = $_POST['correction_id_from_edit_marking'];

		$answer_set->question = $question_from_edit_marking;
		$answer_set->question_id = $question_id_from_edit_marking;
		$answer_set->answer = $answer_from_edit_marking;
		$answer_set->answer_id = $answer_id_from_edit_marking;
		$answer_set->correction_id = $correction_id_from_edit_marking;

	} else
		if ($view_state == FROM_DONE_VIEW) { //完了画面から遷移した場合
			$answer_set->answer = $_SESSION['ANSWER'];
			$answer_set->answer_id = $_SESSION['ANSWER_ID'];
			$answer_set->question = $_SESSION['PROBLEM'];
			$answer_set->question_id = $_SESSION['PROBLEM_ID'];
		}
	return $answer_set;
}

/*******************
*画面遷移後の処理***
********************/

//日付を取得する
$today = date('Y年m月d日');
//添削と画面の状態を取得する
$correction_view_state = getCorrectionAndViewState();
//添削に必要な情報を取得する
$correction_state = $correction_view_state->correction_state;
$view_state = $correction_view_state->view_state;
$answer_set = getDataForCorrection($correction_state, $view_state);

$uneditedanswer = $answer_set->answer;
$uneditedanswerquestion = $answer_set->question;
$uneditedanswerquestionid = $answer_set->question_id;
?>

<h1 align="center">添削画面</h1><br><br>
<table align="center">

<?php
//添削する問題と回答を保存する
$_SESSION['ANSWER_SET']=$answer_set;
$_SESSION['PROBLEM'] = $answer_set->question;
$_SESSION['PROBLEM_ID'] = $answer_set->question_id;
$_SESSION['ANSWER'] = $answer_set->answer;
$_SESSION['ANSWER_ID'] = $answer_set->answer_id;
//if($answer_set->correction_id){
//$_SESSION['CORRECTION_ID'] = $answer_set->correction_id;
//}

$html =<<<EOD
<h4>まず、正解か不正解かを選んでください。</h4>
<form method="post" action="Correction_Completed.php" >
<input type="hidden" name="category" value="1">
<input type="hidden" name = "comment" value="">
<input type="submit" value="正解">
</form>

<form>
<input type="button" onClick="location.href='Correction_Review.php'" value="不正解">
</form>
<HR>
<form>
<input type="button" onClick="location.href='TeacherTop.php'" value="TOPページに戻る">
</form>
EOD;

if ($uneditedanswer) {
	print "
					<h2>添削する回答</h2>
					<h3>問題文：$uneditedanswerquestion</h3>
					<h3>回答文：$uneditedanswer</h3>
					<br>
					";
	print $html;
} else {
	print "<h3>未処理の回答はありません</h3>
					<form>
					<input type=\"button\" onClick=\"location.href='TeacherTop.php'\" value=\"TOPページに戻る\">
					</form>
					";
}
?>


</body>
</html>