<?
// セッションを開始。
session_start();
// セッションに変数を登録
$_SESSION['PROBLEM'];
$_SESSION['PROBLEM_ID'];
$_SESSION['ANSWER'];
?>


<?php
require_once("../DBAccessors/MarkingData.php");
require_once("../Common/HTMLNormalizer.php");
require_once("../DBAccessors/CorrectionKindData.php");

$correction_state = 0;//添削の状態
define("NEW_CORRECTION","1");
define("ADD_CORRECTION","2");
define("OVERWRITE_CORRECTION","3");

$view_state =0;//画面の状態
define("FROM_MENU_VIEW","1");
define("FROM_DONE_VIEW","2");
define("FROM_EDIT_VIEW","3");
define("FROM_THIS_VIEW","4");

/**
 * 添削の状態を取得する
 */
function getCorrectionAndViewState(){
	$view_state = FROM_MENU_VIEW;
	
	if(isset($_POST['same_answer'])){//添削完了画面でフラグを渡された場合
		$correction_state = ADD_CORRECTION;
		$view_state=FROM_DONE_VIEW;
	}else if(isset($_POST['answer_from_edit_marking'])){//添削編集画面でフラグを渡された場合
		if(isset($_POST['redo'])){//上書きの場合
			$view_state=FROM_EDIT_VIEW;
			$correction_state = OVERWRITE_CORRECTION;
		}else{//追加の場合
			$view_state=FROM_EDIT_VIEW;
			$correction_state = ADD_CORRECTION;
		} 
	}else if (isset($_POST['add_category'])){
		$view_state=FROM_THIS_VIEW;
		$correction_state = NEW_CORRECTION;
	}else{//まったくフラグがない場合
		$correction_state = NEW_CORRECTION;
	}
	
	$correction_view_state->correction_state=$correction_state;
	$correction_view_state->view_state=$view_state;

	return $correction_view_state;
}

$correction_view_state=getCorrectionAndViewState();
$view_state=$correction_view_state->view_state;
$correction_state=$correction_view_state->correction_state;
echo $view_state;
echo $correction_state;

/**
 * 添削に必要な情報を取得する
 */
function getDataForCorrection($correction_state,$view_state){
	//添削の状態を調べて
	if($correction_state == NEW_CORRECTION){
	//添削がされていない場合は
		//DBからデータを読み込む
		$answer_set=getAnswerSetFromDB();
	}else if($correction_state == OVERWRITE_CORRECTION){
	//添削をやり直す場合は
		//画面からデータを読み込む
		$answer_set=getAnswerSetFromView($view_state);
		$answer_id=$answer_set->answer_id;
		$correction_id=$answer_set->correction_id;
		//DBから添削データを消去する
		deleteCorrection($correction_id,$answer_id);
	}else if($correction_state == ADD_CORRECTION){
	//添削を追加する場合は
		//画面からデータを読み込む
		$answer_set=getAnswerSetFromView($view_state);
	}
	
	return $answer_set;
}

/**
 * 添削用データをDBから取得する
 */
function getAnswerSetFromDB(){
	$answer_set=getUnCorrectedAnswerSet();
	return $answer_set;
}

/**
 * 添削用データを画面から取得する
 */
 echo $view_state;
 echo $view_state;
function getAnswerSetFromView($view_state){
	if($view_state==FROM_EDIT_VIEW){//編集画面から遷移した場合
		$answer_from_edit_marking = $_POST['answer_from_edit_marking'];
		$answer_id_from_edit_marking = $_POST['answer_id_from_edit_marking'];
		$question_from_edit_marking = $_POST['question_from_edit_marking'];
		$question_id_from_edit_marking = $_POST['question_id_from_edit_marking'];
		$correction_id_from_edit_marking = $_POST['correction_id_from_edit_marking'];
		
		$answer_set->question=$question_from_edit_marking;
		$answer_set->question_id=$question_id_from_edit_marking;
		$answer_set->answer=$answer_from_edit_marking;
		$answer_set->answer_id=$answer_id_from_edit_marking;
		$answer_set->correction_id=$correction_id_from_edit_marking;	
		
	}else if($view_state==FROM_DONE_VIEW){//完了画面から遷移した場合
		$answer_set->answer=$_SESSION['ANSWER'];
		$answer_set->answer_id=$_SESSION['ANSWER_ID'];
		$answer_set->question=$_SESSION['PROBLEM'];
		$answer_set->question_id=$_SESSION['PROBLEM_ID'];
	}
	return $answer_set;
}
	
/******
 * 不正解の位置を入力するチェックボックスを表示する
 */
 function make_checkboxed_answer($answer){
	$size_of_answer=mb_strlen($answer);//問題文の文字数
 	$checkbox_added_answer="";
 	$letter_pointer=0;
 	while($letter_pointer<$size_of_answer){
 		$letter = mb_substr($answer,$letter_pointer, 1);
 		$letter=$letter."<input type=\"checkbox\" name=\"letters[]\" value=\"$letter_pointer\">\n";
 		$checkbox_added_answer=$checkbox_added_answer.$letter;
 		$letter_pointer++;
 	}
 	print $checkbox_added_answer;
 }

